#!/usr/bin/perl

#############################################
# BrowserMatcher
# By: Wolfgang Melchior Citro Communications: http://www.citro.net
# support@citro.net
# 06/28/98
# Download Location: http://www.citro.net/scripts/more.shtml
# COPYRIGHT NOTICE                                                           # Copyright 1998-99 Wolfgang Melchior . All rights reserved
# By using this code you agree to indemnify Wolfgang Melchior and 
# Citro Communications from any liability that  might arise from it's 
# use. Selling or reselling the code of this program is expressly 
# forbidden. It is freeware, so you may copy and redistribute it as 
# often as you want as long as this copyright header remains intact.

####################
### INSTALLATION ###
####################
# 1. Unpack and upload the pl-file onto your server (cgi-bin) and chmod 755. Place the the file index.shtml in your html start diretory.
# 2. Change the first line above to point to your server's Perl interpreter. You only have to change this on UNIX servers.
#
################
##   Setup	  ##
################
# 1. Edit variable for the directory where your html pages reside: $htmldir
# 2. Edit variable for the extensions of your html pages: $extension
# 3. Edit the variable for the default index page that will be opened if unknown browser is detected or the page $page for a browser does not exist on your server. Use relative path or the full server path no URL!
# 4. Tell BrowserMatcher whether it should parse the page within its script (URL = browser_matcher.pl) or redirect to the new location (URL = page.html).
# 5. Enter your own Password $pw to access the Logfile
# 6. Specify your own name for the logfile $logfile (absolute or relative server path)
# 8 Decide whether Mozilla browsers (Internet Explorer and Netscape) should be redirected to pages with fixed names (Netscape 4.01 and Netscape 4.02 and Netscape 4.03 always to e.g. netscape4.html) => $moz_option="fixed"; or whether they should be redirected to auto-generated pages that carry the full name of the version: Netscape 4.01 browsers would be redirected to netscape4.01.html then.
# 7. Go through the list of browsers (%browsers) and add your type and the names that will be displayed on auto-generated HTML-pages
# types_and_pagenames: the browser type = the name of the HTML-page
# displayed_names: the browser names that will be displayed on auto-generated HTML-pages

####### The Setup Options ################

$htmldir = "../../../browse/"; # directory of your HTML start pages

$extension = "shtml"; # extension of these pages

$defaultpage = "../../../browse/index.shtml"; # the HTML default page

$parse = "yes"; # if set to yes each page is diplayed WITHIN the script (URL = script URL), otherwise browsermatcher will transfer to the HTML page.

$pw = "admin"; # password to see the logfile

$logfile = "browserlog"; # name of logfile

$moz_option = "fixed"; # fixed page (fixed) or auto-generated page (auto)

$vermax = "5";

%browsers = (
types_and_pagenames => ['lynx','mosaic','aol','opera','java','macweb','webexplorer','omniweb'],
displayed_names => ['Lynx','MOSAIC','AOL','Opera','JAVA','MacWeb','WebExplorer','OmniWeb']
);


$demo = "yes";


#############################################################
###### End of Setup Options #################################
###### DO NOT EDIT ANYTHING below these lines!!!#############
#############################################################


#print "Content-type: text/html\n\n";
$type = $ENV{'HTTP_USER_AGENT'};


if ($ENV{'QUERY_STRING'} eq "$pw")
{
&adminpage;
}

################################################
# Routine for Other Browsers (see list)  #######
################################################
foreach $all ( keys %browsers ) 
{
foreach $i ( 0..$#{$browsers{$all}} ) 
{
if ($type =~ /$browsers{'types_and_pagenames'}[$i]/i)
{
$page = $browsers{'types_and_pagenames'}[$i];
$displayed = $browsers{'displayed_names'}[$i];
}
}
}

#print "Page: $page<br>Displayed: $displayed";
#exit;


################################################
# Routine for Netscape and MSIE versions #######
################################################

######### 1. Netscape ##############
if ($type =~ /Mozilla/i && $type !~ /MSIE/i)
{
@parts = split(/\(/,$type);
($trash,$nsbrowser) = split(/\//,$parts[0]);


# Option 1: Generated names: auto
if ($moz_option eq "auto")
{
## $nsbrowser contains Netscapes version number
$page = "netscape".$nsbrowser;
}

# Option 2: Fixed names: fixed
if ($moz_option eq "fixed")
{
for ($vernum=1;$vernum<=$vermax;$vernum++)
{
if ($type =~ /Mozilla\/$vernum/i) 
{
$page="netcape".$vernum;
}
}
}

$displayed = "Netscape Navigator $nsbrowser";
}

########## Opera ########################
if ($type =~ /Mozilla/i && $type =~ /Opera/i)
{
@parts = split(/\(/,$type);
($trash,$nsbrowser) = split(/\//,$parts[0]);


# Option 1: Generated names: auto
if ($moz_option eq "auto")
{
## $nsbrowser contains Netscapes version number
$page = "opera".$nsbrowser;
}

# Option 2: Fixed names: fixed
if ($moz_option eq "fixed")
{
for ($vernum=1;$vernum<=$vermax;$vernum++)
{
if ($type =~ /Mozilla\/$vernum/i) 
{
$page="opera".$vernum;
}
}
}

$displayed = "Opera $nsbrowser";
}



######### 2. Internet Explorer ##############
if ($type =~ /Mozilla/i && $type =~ /MSIE/i)
{
@parts = split(/\(/,$type);
@restparts = split(/\;/,$parts[1]);

## $restparts[1] contains Internet Microsofts version number

$displayed = "Microsoft Internet Explorer $restparts[1]";
$restparts[1] =~ s/ //gi;
if ($moz_option eq "auto")
{
$page = "$restparts[1]";
}

if ($moz_option eq "fixed")
{
for ($vernum=1;$vernum<=$vermax;$vernum++)
{
if ($type =~ /MSIE $vernum/i) 
{
$page = "msie".$vernum;
}
}
}

} #end of mozilla check


################################################
#        Routine for unknown browsers    #######
################################################

if ($page eq "" && $displayed eq "")
{
$page="unknown";
$displayed = "$type (unknown)";
}

#print "$type<br>$nsbrowser<br>$msiebrowser<br>$parts[1]$page";
#exit;



&get_date;
&logit;

############################################

if (-e "$htmldir$page.$extension")
{
if ($parse eq "yes")
{
print "Content-type: text/html\n\n";
open (PAGE, "$htmldir$page.$extension");
while (<PAGE>) 
{
s/<!--browser-->/$displayed/gi;
print "$_";
}
close(PAGE);
}
elsif ($parse ne "yes")
{
print "Location: $htmldir$page.$extension\n\n";
}
}


else
{
open (PAGE, "$defaultpage");
while (<PAGE>) 
{
s/<!--browser-->/$displayed/gi;
$content .= $_;
}
close(PAGE);


open (PAGE, ">$htmldir$page.$extension");
print PAGE "$content";
close(PAGE);

print "Location: $htmldir$page.$extension\n\n";

}

sub no_open {
local($dir,$files,$filename,$lineno,$action) = @_;
print "Content-type: text/html\n\n";
print qq~
<table>
<tr>
<td>
<H2 align=center>Error in $filename at line $lineno while $action! <p>Couldnt find or open required file or directory <i>$dir$files</i></h2>
<h2>Please check <ul>
<li> the path or name of this file or directory ,
<li> check its permissions (many files must be writable by the server or owner = chmod 6xx or higher): on some servers the directories and files must be chmod 777 to perform write and read operation within and on them
<li> or create the directory or file manually if it doesnt exist and all trouble shooting before failed.
</ul>
</td></tr></table>
~;

exit;
}


sub logit
{
open(FILE,">>$logfile"); 
print FILE "$displayed\|$htmldir$page.$extension\|$ENV{'HTTP_USER_AGENT'}\|$ENV{'REMOTE_HOST'}\|$ENV{'SERVER_NAME'}\|$ENV{'HTTP_ACCEPT_LANGUAGE'}\|$ENV{'HTTP_REFERER'}\|$ENV{'REMOTE IDENT'}\|$date\n";
close(FILE);
}



sub adminpage
{
open(FILE,"$logfile"); 
@logs = <FILE>; 
close(FILE);

$log_num = @logs-1;

print "Content-type: text/html\n\n";
print qq~
<h3>Please hold on while BrowserMatcher is loading $log_num logged records</h3>
<table border=2>
<tr><th>Browser</th><th>Page</th><th>User Agent</th><th>Remote Host</th><th>Server Name</th><th>Language</th><th>Referer</th><th>Identity</th><th>Date</th></tr>
~;
$count = 0;
foreach $l (@logs)
{
$count++;
@fields = split (/\|/,$l);
print qq~
<tr>
<td>$count</td>
~;
foreach $f (@fields)
{
print "<td>&nbsp;$f</td>";
}
print "</tr>";
}
print qq~
</table>
~;
exit;
}


sub get_date {

# Days of the week
@d_days   = ('Sonntag','Montag','Dienstag','Mittwoch',
               'Donnerstag','Freitag','Samstag');

# Month of the year			   
@d_months = ('Januar','Februar','Maerz','April','Mai','Juni','Juli',
	         'August','September','Oktober','November','Dezember');

@days   = ('Sunday','Monday','Tuesday','Wednesday',
               'Thursday','Friday','Saturday');

# Month of the year			   
@months = ('January','February','March','April','May','June','July',
	         'August','September','October','November','December');



    # Define arrays for the day of the week and month of the year.           #

    # Get the current time and format the hour, minutes and seconds.  Add    #
    # 1900 to the year to get the full 4 digit year.                         #
    ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0,1,2,3,4,5,6];
    $time = sprintf("%02d:%02d:%02d",$hour,$min,$sec);
    $year += 1900;

$hours = $hour;
$years = $year;
$mdays = $mday;
$mons = $mon;
$wdays = $wday;



	if ($hours < 10)
    {
    $hours = "0$hours";
    }
	if ($min < 10) 
    {
    $min = "0$min";
    }
	if ($sec < 10)
    { 
	$sec = "0$sec";
    }
	if ($mday < 10)
	{
	$mday = "0$mday";	
	}


	$time = "$hours:$min:$sec";


    # Format the date.                                                       
    $date = "$days[$wdays],$mdays/$months[$mons]/$years, $time";

}


exit;